//    
//            
//   2^N*PointGrid      
//          
//.        PointGrid
#include <Trade\Trade.mqh>
#include <Trade\OrderInfo.mqh>
#include <Trade\PositionInfo.mqh>
#include <Trade\AccountInfo.mqh>
//--- input parameters
input int      PointGrid=30;//  30-100  10
//-----------------------------------------------------------------------------
bool firstate=true;//   
bool werk=false;//      
ulong Mg=111 ;
double   firlot=0.1;//  
MqlTradeRequest requestmy;
MqlTradeResult  resultmy;
MqlDateTime     time;//
MqlTick pricemy;      //     /  
CTrade   trade;// 
COrderInfo orderinfo;//  
CPositionInfo  posinfo;//  
CAccountInfo   accinfo;
//================================================================
int OnInit()
  { return(0); }
//==============================================================================
void OnDeinit(const int reason)
  {  }
//==============================================================================
int GetTipePos()
   {//    1  -1  0   
      if(PositionSelect(_Symbol) == true)
         {
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
               { return(1); }
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
               { return(-1); }
         }
      return(0);
   }
//==============================================================================
void  SetOrder()
   {//  
      SymbolInfoTick(_Symbol,pricemy);//   
      int i ,aaa ;
      double tpbuy,tpsell,oppossel,lotmy,opposbuy;
      for(i=0 ;i<=10 ;i++)
         {
            aaa=i-1 ;
            if(aaa < 0 ) aaa=0 ;
            lotmy=firlot*pow(2,aaa) ;//   
            trade.SetExpertMagicNumber(Mg);// 
            //-------------------------------------------------------
            oppossel=NormalizeDouble(pricemy.bid+PointGrid*_Point*pow(2,i),_Digits) ;//   sell
            tpsell=NormalizeDouble(oppossel-PointGrid*_Point*pow(2,aaa),_Digits) ; 
            trade.SellLimit(lotmy,oppossel,NULL,0,tpsell,0,0,NULL) ;
            //----------------------------------------------------------
            opposbuy=NormalizeDouble(pricemy.ask-PointGrid*_Point*pow(2,i),_Digits) ;
            tpbuy=NormalizeDouble(opposbuy+PointGrid*_Point*pow(2,aaa),_Digits) ;
            trade.BuyLimit(lotmy,opposbuy,NULL,0,tpbuy,0,0,NULL) ;
         }
      
      return ;
   }
//=============================================================================
void  DelOrder(ENUM_ORDER_TYPE tipeorder)
   {//  
   int i,total=OrdersTotal();
   ulong ticket;
   for(i=total-1; i>=0;i--)
     {
      if((ticket=OrderGetTicket(i))>0)
         if(Mg==orderinfo.Magic() && orderinfo.Symbol() ==_Symbol && orderinfo.OrderType()== tipeorder)
           {
            trade.OrderDelete(ticket);
           }
     }
      return;
   }
//===========================================================================
void OnTick()
  {
      if(GetTipePos()== 0 && firstate)
         {//          
            DelOrder(ORDER_TYPE_BUY_LIMIT);//   
            DelOrder(ORDER_TYPE_SELL_LIMIT);//   
            SetOrder();//     
            firstate=false ;//  
            werk=true ;//    
         }
      /*if(GetTipePos() == 0 && !werk)
         {//          
            DelOrder(ORDER_TYPE_BUY_LIMIT);//   
            DelOrder(ORDER_TYPE_SELL_LIMIT);//   
            firstate=true;
         }*/
      if(GetTipePos() ==1 )
         {//       
            DelOrder(ORDER_TYPE_SELL_LIMIT);
            firstate=true ;
         }
      if(GetTipePos() == -1)
         {//       
            DelOrder(ORDER_TYPE_BUY_LIMIT);
            firstate=true ;
         }
      
   
  }
//+------------------------------------------------------------------+
